#include "CRC_UDM.h"
#include "can.h"
#include "Global_Variable.h"

#define CRC_TABLELENGTH 256u
#define UINT8_MAX ((uint8)0xFF)


/*@!Encoding:949*/


#define CRC8_TABLELENGTH 256u

static const uint8 CRC8_J1850_TABLE[256]=
{
0x00, 0x1D, 0x3A, 0x27, 0x74, 0x69, 0x4E, 0x53,
0xE8, 0xF5, 0xD2, 0xCF, 0x9C, 0x81, 0xA6, 0xBB,
0xCD, 0xD0, 0xF7, 0xEA, 0xB9, 0xA4, 0x83, 0x9E,
0x25, 0x38, 0x1F, 0x02, 0x51, 0x4C, 0x6B, 0x76,
0x87, 0x9A, 0xBD, 0xA0, 0xF3, 0xEE, 0xC9, 0xD4,
0x6F, 0x72, 0x55, 0x48, 0x1B, 0x06, 0x21, 0x3C,
0x4A, 0x57, 0x70, 0x6D, 0x3E, 0x23, 0x04, 0x19,
0xA2, 0xBF, 0x98, 0x85, 0xD6, 0xCB, 0xEC, 0xF1,
0x13, 0x0E, 0x29, 0x34, 0x67, 0x7A, 0x5D, 0x40,
0xFB, 0xE6, 0xC1, 0xDC, 0x8F, 0x92, 0xB5, 0xA8,
0xDE, 0xC3, 0xE4, 0xF9, 0xAA, 0xB7, 0x90, 0x8D,
0x36, 0x2B, 0x0C, 0x11, 0x42, 0x5F, 0x78, 0x65,
0x94, 0x89, 0xAE, 0xB3, 0xE0, 0xFD, 0xDA, 0xC7,
0x7C, 0x61, 0x46, 0x5B, 0x08, 0x15, 0x32, 0x2F,
0x59, 0x44, 0x63, 0x7E, 0x2D, 0x30, 0x17, 0x0A,
0xB1, 0xAC, 0x8B, 0x96, 0xC5, 0xD8, 0xFF, 0xE2,
0x26, 0x3B, 0x1C, 0x01, 0x52, 0x4F, 0x68, 0x75,
0xCE, 0xD3, 0xF4, 0xE9, 0xBA, 0xA7, 0x80, 0x9D,
0xEB, 0xF6, 0xD1, 0xCC, 0x9F, 0x82, 0xA5, 0xB8,
0x03, 0x1E, 0x39, 0x24, 0x77, 0x6A, 0x4D, 0x50,
0xA1, 0xBC, 0x9B, 0x86, 0xD5, 0xC8, 0xEF, 0xF2,
0x49, 0x54, 0x73, 0x6E, 0x3D, 0x20, 0x07, 0x1A,
0x6C, 0x71, 0x56, 0x4B, 0x18, 0x05, 0x22, 0x3F,
0x84, 0x99, 0xBE, 0xA3, 0xF0, 0xED, 0xCA, 0xD7,
0x35, 0x28, 0x0F, 0x12, 0x41, 0x5C, 0x7B, 0x66,
0xDD, 0xC0, 0xE7, 0xFA, 0xA9, 0xB4, 0x93, 0x8E,
0xF8, 0xE5, 0xC2, 0xDF, 0x8C, 0x91, 0xB6, 0xAB,
0x10, 0x0D, 0x2A, 0x37, 0x64, 0x79, 0x5E, 0x43,
0xB2, 0xAF, 0x88, 0x95, 0xC6, 0xDB, 0xFC, 0xE1,
0x5A, 0x47, 0x60, 0x7D, 0x2E, 0x33, 0x14, 0x09,
0x7F, 0x62, 0x45, 0x58, 0x0B, 0x16, 0x31, 0x2C,
0x97, 0x8A, 0xAD, 0xB0, 0xE3, 0xFE, 0xD9, 0xC4
};

// 얼라이브 카운터
int PublicTimer(int b)
{
  if (b<255)
  {
    b++;
  }
  else
  {
    b= 0;
  }
  return b;
}

unsigned long crclib_getCRC8(const uint8 *xData, uint16 xDatalen)
{

	uint8 idx;
	uint8 crc = UINT8_MAX;

	for(idx=0; idx < xDatalen ; idx++){

		crc =CRC8_J1850_TABLE[crc ^(xData[idx])];

	}
	crc^=UINT8_MAX;
	return crc;

}

unsigned long Proxy_CalChksm_IDB_BrakeEcuStatus_CAN(unsigned char data[])
{

	uint8 CalcChecksum;
	CalcChecksum = crclib_getCRC8(&data[1],7);
	return CalcChecksum;
}




#if 1


// ===========================RWA1 작동 CRC========================================
unsigned long CRC8_Func_FOR_RWA1(long aId, int xDatalen, unsigned char data[])
{
  unsigned long ret = 1;
  int CrcDlc = xDatalen - 2;
  unsigned short DataId = aId;
  unsigned short WrongDataId; /* Edited(Oct 05th, 2018)*/
  // =============================RWA1 작동 CRC ==============================================
  if(aId == 0x310)/*BSC_RWA_StartupCommand_CH2_0x310*/
  {
		ECU3.TX.CH2_BSC_RWA_StartupCommand_0x310.Arc = PublicTimer(ECU3.TX.CH2_BSC_RWA_StartupCommand_0x310.Arc);
		data[1] = ECU3.TX.CH2_BSC_RWA_StartupCommand_0x310.Arc;

		GV_RWA_310_Arc = ECU3.TX.CH2_BSC_RWA_StartupCommand_0x310.Arc;

		ECU3.TX.CH2_BSC_RWA_StartupCommand_0x310.Crc= Proxy_CalChksm_IDB_BrakeEcuStatus_CAN(data);
	    data[0] = ECU3.TX.CH2_BSC_RWA_StartupCommand_0x310.Crc;

	    GV_RWA_310_Crc = ECU3.TX.CH2_BSC_RWA_StartupCommand_0x310.Crc;
  }

  if(aId == 0x040)
  {
		ECU3.TX.CH2_BSC_RWA_RackCommand_0x040.Arc = PublicTimer(ECU3.TX.CH2_BSC_RWA_RackCommand_0x040.Arc);
		data[1] = ECU3.TX.CH2_BSC_RWA_RackCommand_0x040.Arc;

		GV_RWA_040_Arc = ECU3.TX.CH2_BSC_RWA_RackCommand_0x040.Arc;

		ECU3.TX.CH2_BSC_RWA_RackCommand_0x040.Crc= Proxy_CalChksm_IDB_BrakeEcuStatus_CAN(data);
	    data[0] = ECU3.TX.CH2_BSC_RWA_RackCommand_0x040.Crc;

	    GV_RWA_040_Crc = ECU3.TX.CH2_BSC_RWA_RackCommand_0x040.Crc;
  }

  if(aId == 0x350)
  {
		ECU3.TX.CH2_BSC_RWA_Sister_0x350.Arc = PublicTimer(ECU3.TX.CH2_BSC_RWA_Sister_0x350.Arc);
		data[1] = ECU3.TX.CH2_BSC_RWA_Sister_0x350.Arc;

		GV_RWA_350_Arc = ECU3.TX.CH2_BSC_RWA_Sister_0x350.Arc;

		ECU3.TX.CH2_BSC_RWA_Sister_0x350.Crc= Proxy_CalChksm_IDB_BrakeEcuStatus_CAN(data);
	    data[0] = ECU3.TX.CH2_BSC_RWA_Sister_0x350.Crc;

	    GV_RWA_350_Crc = ECU3.TX.CH2_BSC_RWA_Sister_0x350.Crc;
  }

  return ret;
}

// ===========================RWA2 작동 CRC========================================
unsigned long CRC8_Func_FOR_RWA2(long aId, int xDatalen, unsigned char data[])
{
  unsigned long ret = 1;
  int CrcDlc = xDatalen - 2;
  unsigned short DataId = aId;
  unsigned short WrongDataId; /* Edited(Oct 05th, 2018)*/
  if(aId == 0x040)
  {
		ECU3.TX.CH3_BSC_RWA_RackCommand_0x040.Arc = PublicTimer(ECU3.TX.CH3_BSC_RWA_RackCommand_0x040.Arc);
		data[1] = ECU3.TX.CH3_BSC_RWA_RackCommand_0x040.Arc;

		GV_RWA2_040_Arc = ECU3.TX.CH3_BSC_RWA_RackCommand_0x040.Arc;

		ECU3.TX.CH3_BSC_RWA_RackCommand_0x040.Crc= Proxy_CalChksm_IDB_BrakeEcuStatus_CAN(data);
	    data[0] = ECU3.TX.CH3_BSC_RWA_RackCommand_0x040.Crc;

	    GV_RWA2_040_Crc = ECU3.TX.CH3_BSC_RWA_RackCommand_0x040.Crc;
  }

  if(aId == 0x350)
  {
		ECU3.TX.CH3_BSC_RWA_Sister_0x350.Arc = PublicTimer(ECU3.TX.CH3_BSC_RWA_Sister_0x350.Arc);
		data[1] = ECU3.TX.CH3_BSC_RWA_Sister_0x350.Arc;

		GV_RWA2_350_Arc = ECU3.TX.CH3_BSC_RWA_Sister_0x350.Arc;

		ECU3.TX.CH3_BSC_RWA_Sister_0x350.Crc= Proxy_CalChksm_IDB_BrakeEcuStatus_CAN(data);
	    data[0] = ECU3.TX.CH3_BSC_RWA_Sister_0x350.Crc;

	    GV_RWA2_350_Crc = ECU3.TX.CH3_BSC_RWA_Sister_0x350.Crc;
  }

  if(aId == 0x310)/*BSC_RWA_StartupCommand_CH3_0x310*/
  {
		ECU3.TX.CH3_BSC_RWA_StartupCommand_0x310.Arc = PublicTimer(ECU3.TX.CH3_BSC_RWA_StartupCommand_0x310.Arc);
		data[1] = ECU3.TX.CH3_BSC_RWA_StartupCommand_0x310.Arc;

		GV_RWA2_310_Arc = ECU3.TX.CH3_BSC_RWA_StartupCommand_0x310.Arc;

		ECU3.TX.CH3_BSC_RWA_StartupCommand_0x310.Crc= Proxy_CalChksm_IDB_BrakeEcuStatus_CAN(data);
	    data[0] = ECU3.TX.CH3_BSC_RWA_StartupCommand_0x310.Crc;

	    GV_RWA2_310_Crc = ECU3.TX.CH3_BSC_RWA_StartupCommand_0x310.Crc;
  }

  return ret;
}
// ===========================RWS1 작동 CRC========================================
unsigned long CRC8_Func_FOR_RWS1(long aId, int xDatalen, unsigned char data[])
{
  unsigned long ret = 1;
  int CrcDlc = xDatalen - 2;
  unsigned short DataId = aId;
  unsigned short WrongDataId; /* Edited(Oct 05th, 2018)*/
  if(aId == 0x040)
  {
		ECU3.TX.CH4_VCU_RWS_Rack_Cmd_0x040.Arc = PublicTimer(ECU3.TX.CH3_BSC_RWA_RackCommand_0x040.Arc);
		data[1] = ECU3.TX.CH4_VCU_RWS_Rack_Cmd_0x040.Arc;

		GV_RWS1_040_Arc = ECU3.TX.CH4_VCU_RWS_Rack_Cmd_0x040.Arc;

		ECU3.TX.CH4_VCU_RWS_Rack_Cmd_0x040.Crc= Proxy_CalChksm_IDB_BrakeEcuStatus_CAN(data);
	    data[0] = ECU3.TX.CH4_VCU_RWS_Rack_Cmd_0x040.Crc;

	    GV_RWS1_040_Crc = ECU3.TX.CH4_VCU_RWS_Rack_Cmd_0x040.Crc;
  }

  if(aId == 0x350)
  {
		ECU3.TX.CH4_VCU_RWS_Sister_0x350.Arc = PublicTimer(ECU3.TX.CH4_VCU_RWS_Sister_0x350.Arc);
		data[1] = ECU3.TX.CH4_VCU_RWS_Sister_0x350.Arc;

		GV_RWS1_350_Arc = ECU3.TX.CH4_VCU_RWS_Sister_0x350.Arc;

		ECU3.TX.CH4_VCU_RWS_Sister_0x350.Crc= Proxy_CalChksm_IDB_BrakeEcuStatus_CAN(data);
	    data[0] = ECU3.TX.CH4_VCU_RWS_Sister_0x350.Crc;

	    GV_RWS1_350_Crc = ECU3.TX.CH4_VCU_RWS_Sister_0x350.Crc;
  }

  if(aId == 0x310)/*BSC_RWA_StartupCommand_CH3_0x310*/
  {
		ECU3.TX.CH4_VCU_RWS_StartupCommand_0x310.Arc = PublicTimer(ECU3.TX.CH4_VCU_RWS_StartupCommand_0x310.Arc);
		data[1] = ECU3.TX.CH4_VCU_RWS_StartupCommand_0x310.Arc;

		GV_RWS1_310_Arc = ECU3.TX.CH4_VCU_RWS_StartupCommand_0x310.Arc;

		ECU3.TX.CH4_VCU_RWS_StartupCommand_0x310.Crc= Proxy_CalChksm_IDB_BrakeEcuStatus_CAN(data);
	    data[0] = ECU3.TX.CH4_VCU_RWS_StartupCommand_0x310.Crc;

	    GV_RWS1_310_Crc = ECU3.TX.CH4_VCU_RWS_StartupCommand_0x310.Crc;
  }

  return ret;
}
// ===========================RWS2 작동 CRC========================================
unsigned long CRC8_Func_FOR_RWS2(long aId, int xDatalen, unsigned char data[])
{
  unsigned long ret = 1;
  int CrcDlc = xDatalen - 2;
  unsigned short DataId = aId;
  unsigned short WrongDataId; /* Edited(Oct 05th, 2018)*/
  if(aId == 0x040)
  {
		ECU3.TX.CH5_VCU_RWS_Rack_Cmd_0x040.Arc = PublicTimer(ECU3.TX.CH5_VCU_RWS_Rack_Cmd_0x040.Arc);
		data[1] = ECU3.TX.CH5_VCU_RWS_Rack_Cmd_0x040.Arc;

		GV_RWS2_040_Arc = ECU3.TX.CH5_VCU_RWS_Rack_Cmd_0x040.Arc;

		ECU3.TX.CH5_VCU_RWS_Rack_Cmd_0x040.Crc= Proxy_CalChksm_IDB_BrakeEcuStatus_CAN(data);
	    data[0] = ECU3.TX.CH5_VCU_RWS_Rack_Cmd_0x040.Crc;

	    GV_RWS2_040_Crc = ECU3.TX.CH5_VCU_RWS_Rack_Cmd_0x040.Crc;
  }

  if(aId == 0x350)
  {
		ECU3.TX.CH5_VCU_RWS_Sister_0x350.Arc = PublicTimer(ECU3.TX.CH5_VCU_RWS_Sister_0x350.Arc);
		data[1] = ECU3.TX.CH5_VCU_RWS_Sister_0x350.Arc;

		GV_RWS2_350_Arc = ECU3.TX.CH5_VCU_RWS_Sister_0x350.Arc;

		ECU3.TX.CH5_VCU_RWS_Sister_0x350.Crc= Proxy_CalChksm_IDB_BrakeEcuStatus_CAN(data);
	    data[0] = ECU3.TX.CH5_VCU_RWS_Sister_0x350.Crc;

	    GV_RWS2_350_Crc = ECU3.TX.CH5_VCU_RWS_Sister_0x350.Crc;
  }

  if(aId == 0x310)/*BSC_RWA_StartupCommand_CH3_0x310*/
  {
		ECU3.TX.CH5_VCU_RWS_StartupCommand_0x310.Arc = PublicTimer(ECU3.TX.CH5_VCU_RWS_StartupCommand_0x310.Arc);
		data[1] = ECU3.TX.CH5_VCU_RWS_StartupCommand_0x310.Arc;

		GV_RWS2_310_Arc = ECU3.TX.CH5_VCU_RWS_StartupCommand_0x310.Arc;

		ECU3.TX.CH5_VCU_RWS_StartupCommand_0x310.Crc= Proxy_CalChksm_IDB_BrakeEcuStatus_CAN(data);
	    data[0] = ECU3.TX.CH5_VCU_RWS_StartupCommand_0x310.Crc;

	    GV_RWS2_310_Crc = ECU3.TX.CH5_VCU_RWS_StartupCommand_0x310.Crc;
  }

  return ret;
}










unsigned long CRC8_Func(long aId, int xDatalen, unsigned char data[])
{
  unsigned long ret = 1;
  int CrcDlc = xDatalen - 2;
  unsigned short DataId = aId;
  unsigned short WrongDataId; /* Edited(Oct 05th, 2018)*/

  // CH 0 CAR_STAT_CH0_0x012 //
//  if(aId == 0x012)
//  {
//
//  ECU3.TX.CH0_CAR_STAT_CH0_0x012.CAR_ARC = PublicTimer(ECU3.TX.CH0_CAR_STAT_CH0_0x012.CAR_ARC);
//	data[0] = ECU3.TX.CH0_CAR_STAT_CH0_0x012.CAR_ARC;
//
//	GV_CAR_ARC = ECU3.TX.CH0_CAR_STAT_CH0_0x012.CAR_ARC;
//
//  }

  if(aId == 0x050)
  {

		ECU3.TX.CH0_RWA_RackAngleFbk1_0x050.CAR_ARC = PublicTimer(ECU3.TX.CH0_RWA_RackAngleFbk1_0x050.CAR_ARC);
		data[4] = ECU3.TX.CH0_RWA_RackAngleFbk1_0x050.CAR_ARC;

		GV_CAR_ARC = ECU3.TX.CH0_RWA_RackAngleFbk1_0x050.CAR_ARC;

  }


  if(aId == 0x064)/*BSC_IDB_BrakeCommand*/
  {

	ECU3.TX.CH2_BSC_IDB_BrakeCommand_0x064.Arc = PublicTimer(ECU3.TX.CH2_BSC_IDB_BrakeCommand_0x064.Arc);
	data[1] = ECU3.TX.CH2_BSC_IDB_BrakeCommand_0x064.Arc;

	GV_IDB_064_Arc = ECU3.TX.CH2_BSC_IDB_BrakeCommand_0x064.Arc;



	ECU3.TX.CH2_BSC_IDB_BrakeCommand_0x064.Crc= Proxy_CalChksm_IDB_BrakeEcuStatus_CAN(data);
    data[0] = ECU3.TX.CH2_BSC_IDB_BrakeCommand_0x064.Crc;

    GV_IDB_064_Crc = ECU3.TX.CH2_BSC_IDB_BrakeCommand_0x064.Crc;

  }

  if(aId == 0x065)/*BSC_RCU_BrakeCommand*/
  {

	ECU3.TX.CH3_BSC_RCU_BrakeCommand_0x065.Arc = PublicTimer(ECU3.TX.CH3_BSC_RCU_BrakeCommand_0x065.Arc);
	data[1] = ECU3.TX.CH3_BSC_RCU_BrakeCommand_0x065.Arc;

	GV_RCU_065_Arc = ECU3.TX.CH3_BSC_RCU_BrakeCommand_0x065.Arc;

	ECU3.TX.CH3_BSC_RCU_BrakeCommand_0x065.Crc= Proxy_CalChksm_IDB_BrakeEcuStatus_CAN(data);
    data[0] = ECU3.TX.CH3_BSC_RCU_BrakeCommand_0x065.Crc;

    GV_RCU_065_Crc = ECU3.TX.CH3_BSC_RCU_BrakeCommand_0x065.Crc;

  }

  if(aId == 0x032)/*BSC_IDB_StartupCommand_CH2_0x032*/
  {
		ECU3.TX.CH2_BSC_IDB_StartupCommand_0x032.Arc = PublicTimer(ECU3.TX.CH2_BSC_IDB_StartupCommand_0x032.Arc);
		data[1] = ECU3.TX.CH2_BSC_IDB_StartupCommand_0x032.Arc;

		GV_IDB_032_Arc = ECU3.TX.CH2_BSC_IDB_StartupCommand_0x032.Arc;

		ECU3.TX.CH2_BSC_IDB_StartupCommand_0x032.Crc= Proxy_CalChksm_IDB_BrakeEcuStatus_CAN(data);
	    data[0] = ECU3.TX.CH2_BSC_IDB_StartupCommand_0x032.Crc;

	    GV_IDB_032_Crc = ECU3.TX.CH2_BSC_IDB_StartupCommand_0x032.Crc;
  }




  //=======================================
    if(aId == 0x070)/* CH 2 IMU */
    {

  	ECU3.TX.CH2_BSC_IMU_0x070.Arc = PublicTimer(ECU3.TX.CH2_BSC_IMU_0x070.Arc);
  	data[1] = ECU3.TX.CH2_BSC_IMU_0x070.Arc;

  	GV_IMU_070_Arc = ECU3.TX.CH2_BSC_IMU_0x070.Arc;

  	ECU3.TX.CH2_BSC_IMU_0x070.Crc= Proxy_CalChksm_IDB_BrakeEcuStatus_CAN(data);
      data[0] = ECU3.TX.CH2_BSC_IMU_0x070.Crc;

      GV_IMU_070_Crc = ECU3.TX.CH2_BSC_IMU_0x070.Crc;
    }

    if(aId == 0x071)/* CH 3 IMU */
    {

  	ECU3.TX.CH3_BSC_IMU_0x071.Arc = PublicTimer(ECU3.TX.CH3_BSC_IMU_0x071.Arc);
  	data[1] = ECU3.TX.CH3_BSC_IMU_0x071.Arc;

  	GV_IMU_071_Arc = ECU3.TX.CH3_BSC_IMU_0x071.Arc;

  	ECU3.TX.CH3_BSC_IMU_0x071.Crc= Proxy_CalChksm_IDB_BrakeEcuStatus_CAN(data);
      data[0] = ECU3.TX.CH3_BSC_IMU_0x071.Crc;

      GV_IMU_071_Crc = ECU3.TX.CH3_BSC_IMU_0x071.Crc;

    }
    if(aId == 0x033)/* CH 3 RCU_StartupCommand_CH3_0x033 */
    {

  	ECU3.TX.CH3_BSC_RCU_StartupCommand_0x033.Arc = PublicTimer(ECU3.TX.CH3_BSC_RCU_StartupCommand_0x033.Arc);
  	data[1] = ECU3.TX.CH3_BSC_RCU_StartupCommand_0x033.Arc;

  	GV_RCU_033_Arc = ECU3.TX.CH3_BSC_RCU_StartupCommand_0x033.Arc;

  	ECU3.TX.CH3_BSC_RCU_StartupCommand_0x033.Crc= Proxy_CalChksm_IDB_BrakeEcuStatus_CAN(data);
      data[0] = ECU3.TX.CH3_BSC_RCU_StartupCommand_0x033.Crc;

      GV_RCU_033_Crc = ECU3.TX.CH3_BSC_RCU_StartupCommand_0x033.Crc;

    }



    if(aId == 0x06A)/* CH 2 BSC_RegenCommand_CH2_0x06A */
    {

  	ECU3.TX.CH2_BSC_RegenCommand_0x06A.Arc = PublicTimer(ECU3.TX.CH2_BSC_RegenCommand_0x06A.Arc);
  	data[1] = ECU3.TX.CH2_BSC_RegenCommand_0x06A.Arc;

  	GV_BSC_06A_Arc = ECU3.TX.CH2_BSC_RegenCommand_0x06A.Arc;

  	ECU3.TX.CH2_BSC_RegenCommand_0x06A.Crc= Proxy_CalChksm_IDB_BrakeEcuStatus_CAN(data);
      data[0] = ECU3.TX.CH2_BSC_RegenCommand_0x06A.Crc;

      GV_BSC_06A_Crc = ECU3.TX.CH2_BSC_RegenCommand_0x06A.Crc;

    }




    if(aId == 0x384)/* CH 3 BSC_VehicleEnvironment_CH2_0x384 */
    {

  	ECU3.TX.CH2_BSC_VehicleEnvironment_0x384.Arc = PublicTimer(ECU3.TX.CH2_BSC_VehicleEnvironment_0x384.Arc);
  	data[1] = ECU3.TX.CH2_BSC_VehicleEnvironment_0x384.Arc;

  	GV_Env_384_Arc = ECU3.TX.CH2_BSC_VehicleEnvironment_0x384.Arc;

  	ECU3.TX.CH2_BSC_VehicleEnvironment_0x384.Crc= Proxy_CalChksm_IDB_BrakeEcuStatus_CAN(data);
      data[0] = ECU3.TX.CH2_BSC_VehicleEnvironment_0x384.Crc;

      GV_Env_384_Crc = ECU3.TX.CH2_BSC_VehicleEnvironment_0x384.Crc;

    }

    if(aId == 0x385)/* CH 3 BSC_VehicleEnvironment_CH2_0x385 */
    {

  	ECU3.TX.CH3_BSC_VehicleEnvironment_0x385.Arc = PublicTimer(ECU3.TX.CH3_BSC_VehicleEnvironment_0x385.Arc);
  	data[1] = ECU3.TX.CH3_BSC_VehicleEnvironment_0x385.Arc;

  	GV_Env_385_Arc = ECU3.TX.CH3_BSC_VehicleEnvironment_0x385.Arc;

  	ECU3.TX.CH3_BSC_VehicleEnvironment_0x385.Crc= Proxy_CalChksm_IDB_BrakeEcuStatus_CAN(data);
      data[0] = ECU3.TX.CH3_BSC_VehicleEnvironment_0x385.Crc;

      GV_Env_385_Crc = ECU3.TX.CH3_BSC_VehicleEnvironment_0x385.Crc;

    }



    // CH 1  ACU_CAR_STAT_CH1_0x016 //
    if(aId == 0x016)
    {

  	ECU3.TX.CH1_ACU_CAR_STAT_CH1_0x016.ACU_CAR_ARC = PublicTimer(ECU3.TX.CH1_ACU_CAR_STAT_CH1_0x016.ACU_CAR_ARC);
  	data[1] = ECU3.TX.CH1_ACU_CAR_STAT_CH1_0x016.ACU_CAR_ARC;

  	GV_ACU_CAR_ARC = ECU3.TX.CH1_ACU_CAR_STAT_CH1_0x016.ACU_CAR_ARC;

    }



  return ret;
}

#endif
